//! The main file browser

use crate::templ_data::{files::Files, BaseData};
use actix_web::{web, HttpRequest, HttpResponse, Result};
use askama::Template;

pub async fn render(req: HttpRequest) -> Result<HttpResponse> {
    let files = Files {
        base: BaseData {
            sitename: "dev.spacekookie.de".into(),
            ..BaseData::default()
        },
        readme: None,
        path: "".into(),
    }
    .render()
    .unwrap();

    Ok(HttpResponse::Ok().content_type("text/html").body(files))
}
