//! Walk along a branch parsing commit metadata

use std::collections::{BTreeMap, BTreeSet};

pub struct CommitHistory {
    /// The correct order of commit IDs
    order: Vec<String>,
    /// Map of commit IDs to commit metadata
    meta: BTreeMap<String, CommitNode>,
}

pub struct CommitNode {
    id: String,
    author: String,
    commiter: String,
    message: String,
    touches: BTreeSet<String>,
    time: u64,
}
